<?

require_once("include/bittorrent.inc.php");
require_once("include/general_func.inc.php");

function bark($msg) {
	genbark($msg, "Update failed!");
}

dbconn();

loggedinorreturn();

if (!mkglobal("email:chpassword:passagain"))
	bark("missing form data");

$set = array();

$updateset = array();
$changedemail = $newsecret = 0;

$passwordchanged = $chpassword != "";
if ($passwordchanged) {
	if (strlen($chpassword) > 40)
		bark("Sorry, password is too long (max is 40 chars)");
	if ($chpassword != $passagain)
		bark("The passwords didn't match. Try again.");
	$updateset[] = "passhash = '" . md5($chpassword) . "'";
	$newsecret = 1;
}

if ($email != $CURUSER["email"]) {
	if (!validemail($email))
		bark("That doesn't look like a valid email address.");
	$changedemail = 1;
}

/* ****** */

$urladd = "";

if ($newsecret) {
	$sec = mksecret();
	$updateset[] = "secret = " . sqlesc($sec);
	logincookie($CURUSER["id"], $chpassword, $sec);
}

global $thisdomain;

if ($changedemail) {
	$sec = mksecret();
	$hash = md5($sec . $email . $sec);
	$obemail = urlencode($email);
	$updateset[] = "editsecret = " . sqlesc($sec);
	$body = <<<EOD
You have requested that your user profile (username {$CURUSER["username"]})
on $thisdomain should be updated with this email address ($email) as
user contact.

If you did not do this, please ignore this email. The person who entered your
email address had the IP address {$_SERVER["REMOTE_ADDR"]}. Please do not reply.

To complete the update of your user profile, please follow this link:

$tracker_url/confirmemail.php/{$CURUSER["id"]}/$hash/$obemail

Your new email address will appear in your profile after you do this. Otherwise
your profile will remain unchanged.
EOD;

	mail2($email, $body, "$thisdomain profile change confirmation");

	$urladd .= "&mailsent=1";
}

if (count($updateset) == 0)
	plainconfirmation("No changes were made to your profile", "profile.php", "Profile not changed");

safequery("UPDATE user SET " . implode(",", $updateset) . " WHERE id = " . $CURUSER["id"]);

if ($passwordchanged)
{
	plainconfirmation("Your password was changed, you will need to relogin because of security reasons.", "logout.php", "Login required");
}
else
{
	returnto("profile.php?edited=1" . $urladd);
}
?>
