<?
require_once("include/bittorrent.inc.php");
require_once("include/general_func.inc.php");
require_once("include/core_func.inc.php");

dbconn();

loggedinorreturn();

if (empty($_GET["ip"]))
	usererr("IP missing");

if (empty($_GET["port"]))
	usererr("Port missing");

$ip = trim($_GET["ip"]);
$port = intval(trim($_GET["port"]));

if ($port < 1 || $port > 0xffff)
	usererr("Invalid port $port");

$peer_count = safequery_scalar("SELECT COUNT(*) FROM peer WHERE ip = ".sqlesc($ip)." AND port = ".$port);
if ($peer_count < 1)
	usererr("Peer not found");

showheader("Testing $ip:$port");

global $public_ip, $local_ip;

if ($ip == $public_ip)
{
	echo "Connecting to $local_ip instead of $ip (client is in the same NAT as tracker)<br>";
}

$is_connectable = is_connectable($ip, $port);

if ($is_connectable)
	$str = "yes";
else
	$str = "no";

echo "Test complete. Result: ";

show_connectable($is_connectable);

safequery("UPDATE peer SET connectable = '$str' WHERE ip = '$ip' AND port = $port AND connectable <> '$str'");
$aff = mysql_affected_rows();
if ($aff > 0)
	echo "<br><br>" . $aff . " peer(s) were updated";
else
	echo "<br><br>No peers were updated";

stdfoot();

?>
